package net.sf.sql2java.generator.events;

import net.sf.sql2java.common.parameters.StringParser;
import net.sf.sql2java.common.parameters.handlers.NodeParameterHandler;
import net.sf.sql2java.data.node.Nodelet;

import org.apache.velocity.app.event.ReferenceInsertionEventHandler;

public class ParameterStringReference implements ReferenceInsertionEventHandler {
	private StringParser parser;
	
// -- Constructors ------------------------------------------------------------
	
	public ParameterStringReference() {
		this.parser = new StringParser();
	}
	
	public ParameterStringReference(Nodelet node) {
		this.parser = new StringParser(new NodeParameterHandler(node));
	}
	
// -- Implementations ---------------------------------------------------------

	@Override
	public Object referenceInsert(String reference, Object value) {
		// -- return the value if it isn't a string
		if (! (value instanceof String)) return value;
		
		// -- convert the value to a String
		String result = value.toString();
		
		// -- parse the string
		result = parser.parse(result);
		
		// -- return the result
		return result;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setNode(Nodelet node) {
		parser.setHandler(new NodeParameterHandler(node));
	}

}
